Index: trunk/include/iprt/err.h
===================================================================
--- trunk/include/iprt/err.h	(revision 55562)
+++ trunk/include/iprt/err.h	(revision 55658)
@@ -803,5 +803,5 @@
 /** A string claiming to be UTF-8 is incorrectly encoded. */
 #define VERR_INVALID_UTF8_ENCODING          (-61)
-/** Ad string claiming to be in UTF-16 is incorrectly encoded. */
+/** A string claiming to be in UTF-16 is incorrectly encoded. */
 #define VERR_INVALID_UTF16_ENCODING         (-62)
 /** Encountered a unicode code point which cannot be represented as UTF-16. */
@@ -817,5 +817,5 @@
 /** The timer can't be started because it's already active. */
 #define VERR_TIMER_ACTIVE                   (-68)
-/** The timer can't be stopped because i's already suspended. */
+/** The timer can't be stopped because it's already suspended. */
 #define VERR_TIMER_SUSPENDED                (-69)
 /** The operation was cancelled by the user (copy) or another thread (local ipc). */
@@ -1198,5 +1198,5 @@
 /** Wrong release order detected. */
 #define VERR_SEM_LV_WRONG_RELEASE_ORDER     (-369)
-/** Attempt to recursively enter a non-recurisve lock. */
+/** Attempt to recursively enter a non-recursive lock. */
 #define VERR_SEM_LV_NESTED                  (-370)
 /** Invalid parameters passed to the lock validator. */
@@ -1815,7 +1815,7 @@
 /** The VFS object type is not known. */
 #define VERR_VFS_CHAIN_UNKNOWN_TYPE                 (-22103)
-/** Expected a left paranthese. */
+/** Expected a left parentheses. */
 #define VERR_VFS_CHAIN_EXPECTED_LEFT_PARENTHESES    (-22104)
-/** Expected a right paranthese. */
+/** Expected a right parentheses. */
 #define VERR_VFS_CHAIN_EXPECTED_RIGHT_PARENTHESES   (-22105)
 /** Expected a provider name. */
@@ -1894,5 +1894,5 @@
 /** The table of content XML document does not have a toc element. */
 #define VERR_XML_TOC_ELEMENT_MISSING                (-22711)
-/** The table of content XML element (toc) has sibilings, we expected it to be
+/** The table of content XML element (toc) has siblings, we expected it to be
  *  an only child or the root element (xar). */
 #define VERR_XML_TOC_ELEMENT_HAS_SIBLINGS           (-22712)
@@ -2115,43 +2115,43 @@
 /** @name More RTLdr status codes.
  * @{ */
-/** Image Verficiation Failure: No Authenticode Signature. */
+/** Image Verification Failure: No Authenticode Signature. */
 #define VERR_LDRVI_NOT_SIGNED                       (-22900)
-/** Image Verficiation Warning: No Authenticode Signature, but on whitelist. */
+/** Image Verification Warning: No Authenticode Signature, but on whitelist. */
 #define VINF_LDRVI_NOT_SIGNED                       (22900)
-/** Image Verficiation Failure: Error reading image headers.  */
+/** Image Verification Failure: Error reading image headers.  */
 #define VERR_LDRVI_READ_ERROR_HDR                   (-22901)
-/** Image Verficiation Failure: Error reading section headers. */
+/** Image Verification Failure: Error reading section headers. */
 #define VERR_LDRVI_READ_ERROR_SHDRS                 (-22902)
-/** Image Verficiation Failure: Error reading authenticode signature data. */
+/** Image Verification Failure: Error reading authenticode signature data. */
 #define VERR_LDRVI_READ_ERROR_SIGNATURE             (-22903)
-/** Image Verficiation Failure: Error reading file for hashing. */
+/** Image Verification Failure: Error reading file for hashing. */
 #define VERR_LDRVI_READ_ERROR_HASH                  (-22904)
-/** Image Verficiation Failure: Error determining the file length. */
+/** Image Verification Failure: Error determining the file length. */
 #define VERR_LDRVI_FILE_LENGTH_ERROR                (-22905)
-/** Image Verficiation Failure: Error allocating memory for state data. */
+/** Image Verification Failure: Error allocating memory for state data. */
 #define VERR_LDRVI_NO_MEMORY_STATE                  (-22906)
-/** Image Verficiation Failure: Error allocating memory for authenticode
+/** Image Verification Failure: Error allocating memory for authenticode
  *  signature data. */
 #define VERR_LDRVI_NO_MEMORY_SIGNATURE              (-22907)
-/** Image Verficiation Failure: Error allocating memory for section headers. */
+/** Image Verification Failure: Error allocating memory for section headers. */
 #define VERR_LDRVI_NO_MEMORY_SHDRS                  (-22908)
-/** Image Verficiation Failure: Authenticode parsing output. */
+/** Image Verification Failure: Authenticode parsing output. */
 #define VERR_LDRVI_NO_MEMORY_PARSE_OUTPUT           (-22909)
-/** Image Verficiation Failure: Invalid security directory entry. */
+/** Image Verification Failure: Invalid security directory entry. */
 #define VERR_LDRVI_INVALID_SECURITY_DIR_ENTRY       (-22910)
-/** Image Verficiation Failure:  */
+/** Image Verification Failure:  */
 #define VERR_LDRVI_BAD_CERT_HDR_LENGTH              (-22911)
-/** Image Verficiation Failure:  */
+/** Image Verification Failure:  */
 #define VERR_LDRVI_BAD_CERT_HDR_REVISION            (-22912)
-/** Image Verficiation Failure:  */
+/** Image Verification Failure:  */
 #define VERR_LDRVI_BAD_CERT_HDR_TYPE                (-22913)
-/** Image Verficiation Failure: More than one certificate table entry.  */
+/** Image Verification Failure: More than one certificate table entry.  */
 #define VERR_LDRVI_BAD_CERT_MULTIPLE                (-22914)
 
-/** Image Verficiation Failure:  */
+/** Image Verification Failure:  */
 #define VERR_LDRVI_BAD_MZ_OFFSET                    (-22915)
-/** Image Verficiation Failure: Invalid section count. */
+/** Image Verification Failure: Invalid section count. */
 #define VERR_LDRVI_INVALID_SECTION_COUNT            (-22916)
-/** Image Verficiation Failure: Raw data offsets and sizes are out of range. */
+/** Image Verification Failure: Raw data offsets and sizes are out of range. */
 #define VERR_LDRVI_SECTION_RAW_DATA_VALUES          (-22917)
 /** Optional header magic and target machine does not match. */
@@ -2174,5 +2174,5 @@
 /** The page hash table is not strictly ordered by offset. */
 #define VERR_LDRVI_PAGE_HASH_TAB_NOT_STRICTLY_SORTED (-22926)
-/** The page hash table hashes data outside the defined and implict sections. */
+/** The page hash table hashes data outside the defined and implicit sections. */
 #define VERR_PAGE_HASH_TAB_HASHES_NON_SECTION_DATA  (-22927)
 /** Page hash mismatch. */
@@ -2210,6 +2210,6 @@
 /** Certificate signature algorithm mismatch. */
 #define VERR_CR_X509_CERT_SIGN_ALGO_MISMATCH        (-23006)
-/** The signature algorithm in the to-be-signed certifcate part does not match
- * the one assoicated with the signature. */
+/** The signature algorithm in the to-be-signed certificate part does not match
+ * the one associated with the signature. */
 #define VERR_CR_X509_CERT_TBS_SIGN_ALGO_MISMATCH    (-23007)
 /** Certificate extensions requires certificate version 3 or later.  */
@@ -2223,5 +2223,5 @@
 /** Public key is too small. */
 #define VERR_CR_X509_PUBLIC_KEY_TOO_SMALL           (-23012)
-/** Invalid strnig tag for a X.509 name object. */
+/** Invalid string tag for a X.509 name object. */
 #define VERR_CR_X509_INVALID_NAME_STRING_TAG        (-23013)
 /** Empty string in X.509 name object. */
@@ -2255,5 +2255,5 @@
  *  certificate authority (CA). */
 #define VERR_CR_X509_CPV_NOT_CA_CERT                (-23026)
-/** Certificate path validator: Intermeidate certificate is not a version 3
+/** Certificate path validator: Intermediate certificate is not a version 3
  *  certificate. */
 #define VERR_CR_X509_CPV_NOT_V3_CERT                (-23027)
@@ -2272,5 +2272,5 @@
 #define VERR_CR_X509_CPV_ISSUER_MISMATCH            (-23032)
 /** Certificate path validator: The certificate is not valid at the
- *  specificed time. */
+ *  specified time. */
 #define VERR_CR_X509_CPV_NOT_VALID_AT_TIME          (-23033)
 /** Certificate path validator: Unexpected choice found in general subtree
@@ -2293,5 +2293,5 @@
 /** Generic PKCS \#7 error. */
 #define VERR_CR_PKCS7_GENERIC_ERROR                             (-23300)
-/** Signed data verfication failed because there are zero signer infos. */
+/** Signed data verification failed because there are zero signer infos. */
 #define VERR_CR_PKCS7_NO_SIGNER_INFOS                           (-23301)
 /** Signed data certificate not found. */
@@ -2339,5 +2339,5 @@
 /** Error creating digest algorithm calculator. */
 #define VERR_CR_PKCS7_DIGEST_CREATE_ERROR                       (-22319)
-/** Error while calculating a digest for a PKCS \#7 verficiation operation. */
+/** Error while calculating a digest for a PKCS \#7 verification operation. */
 #define VERR_CR_PKCS7_DIGEST_CALC_ERROR                         (-22320)
 /** Unsupported PKCS \#7 signed data version. */
@@ -2382,5 +2382,5 @@
 /** The indirect data digest size does not match the digest algorithm. */
 #define VERR_CR_SPC_IND_DATA_DIGEST_SIZE_MISMATCH               (-23406)
-/** Exptected PE image data inside indirect data object. */
+/** Expected PE image data inside indirect data object. */
 #define VERR_CR_SPC_EXPECTED_PE_IMAGE_DATA                      (-23407)
 /** Internal SPC error: The PE image data is missing.  */
@@ -2390,5 +2390,5 @@
 /** Unknown SPC object moniker UUID. */
 #define VERR_CR_SPC_UNKNOWN_MONIKER_UUID                        (-23410)
-/** Internal SPC error: Bad object monker choice value. */
+/** Internal SPC error: Bad object moniker choice value. */
 #define VERR_CR_SPC_BAD_MONIKER_CHOICE                          (-23411)
 /** Internal SPC error: Bad object moniker data pointer. */
@@ -2428,5 +2428,5 @@
 /** PKIX cipher algorithm parameters are not implemented. */
 #define VERR_CR_PKIX_CIPHER_ALGO_PARAMS_NOT_IMPL    (-23510)
-/** ipher algorithm is not known to us. */
+/** Cipher algorithm is not known to us. */
 #define VERR_CR_PKIX_CIPHER_ALGO_NOT_KNOWN          (-23511)
 /** PKIX cipher algorithm is not known to OpenSSL. */
@@ -2471,5 +2471,5 @@
 /** OpenSSL failed to initialize the digest algorithm contextn. */
 #define VERR_CR_DIGEST_OSSL_DIGEST_INIT_ERROR       (-24200)
-/** OpenSSL failed to clone the digest algorithm contextn. */
+/** OpenSSL failed to clone the digest algorithm context. */
 #define VERR_CR_DIGEST_OSSL_DIGEST_CTX_COPY_ERROR   (-24201)
 /** @} */