Index: trunk/src/VBox/Main/src-server/MachineImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 55769)
@@ -5872,5 +5872,5 @@
            )
             propMap.insert(*it);
-        it++;
+        ++it;
     }
 
Index: trunk/src/VBox/Main/src-server/MediumLock.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MediumLock.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/MediumLock.cpp	(revision 55769)
@@ -185,5 +185,5 @@
     for (MediumLockList::Base::iterator it = mMediumLocks.begin();
          it != mMediumLocks.end();
-         it++)
+         ++it)
     {
         if (it->GetMedium() == aMedium)
@@ -224,5 +224,5 @@
     for (MediumLockList::Base::iterator it = mMediumLocks.begin();
          it != mMediumLocks.end();
-         it++)
+         ++it)
     {
         rc = it->Lock(fSkipOverLockedMedia);
@@ -251,5 +251,5 @@
     for (MediumLockList::Base::iterator it = mMediumLocks.begin();
          it != mMediumLocks.end();
-         it++)
+         ++it)
     {
         HRESULT rc2 = it->Unlock();
@@ -345,5 +345,5 @@
     for (MediumLockListMap::Base::const_iterator it = mMediumLocks.begin();
          it != mMediumLocks.end();
-         it++)
+         ++it)
     {
         rc = it->second->Lock();
@@ -372,5 +372,5 @@
     for (MediumLockListMap::Base::const_iterator it = mMediumLocks.begin();
          it != mMediumLocks.end();
-         it++)
+         ++it)
     {
         MediumLockList *pMediumLockList = it->second;
Index: trunk/src/VBox/Main/src-server/Performance.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/Performance.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/Performance.cpp	(revision 55769)
@@ -459,5 +459,5 @@
         mVMMStatsProvider = NULL;
 
-        for (it = mGuests.begin(); it != mGuests.end(); it++)
+        for (it = mGuests.begin(); it != mGuests.end(); ++it)
         {
             /* Skip unregistered as they are about to be destroyed */
@@ -482,5 +482,5 @@
         {
             /* If nobody collects stats, take the first registered */
-            for (it = mGuests.begin(); it != mGuests.end(); it++)
+            for (it = mGuests.begin(); it != mGuests.end(); ++it)
             {
                 /* Skip unregistered as they are about to be destroyed */
@@ -1533,5 +1533,5 @@
 
     //LogAleksey(("Filter::match(%p, %s)\n", static_cast<const IUnknown*> (object), name.c_str()));
-    for (it = mElements.begin(); it != mElements.end(); it++)
+    for (it = mElements.begin(); it != mElements.end(); ++it)
     {
         //LogAleksey(("...matching against(%p, %s)\n", static_cast<const IUnknown*> ((*it).first), (*it).second.c_str()));
Index: trunk/src/VBox/Main/src-server/PerformanceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/PerformanceImpl.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/PerformanceImpl.cpp	(revision 55769)
@@ -729,5 +729,5 @@
     BaseMetricList::iterator it;
     /* Compose the list of metrics being collected at this moment */
-    for (it = m.baseMetrics.begin(); it != m.baseMetrics.end(); it++)
+    for (it = m.baseMetrics.begin(); it != m.baseMetrics.end(); ++it)
         if ((*it)->collectorBeat(timestamp))
         {
Index: trunk/src/VBox/Main/src-server/USBProxyService.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBProxyService.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/USBProxyService.cpp	(revision 55769)
@@ -929,5 +929,5 @@
                               pIgnoreMachine);
             alock.acquire();
-            it++;
+            ++it;
         }
         else
@@ -969,5 +969,5 @@
                  */
                 if (!pHostDevice->i_wasActuallyDetached())
-                    it++;
+                    ++it;
                 else
                 {
Index: trunk/src/VBox/Main/src-server/linux/PerformanceLinux.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/PerformanceLinux.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/linux/PerformanceLinux.cpp	(revision 55769)
@@ -118,5 +118,5 @@
 
     std::vector<RTPROCESS>::iterator it;
-    for (it = processes.begin(); it != processes.end(); it++)
+    for (it = processes.begin(); it != processes.end(); ++it)
     {
         VMProcessStats vmStats;
Index: trunk/src/VBox/Main/src-server/win/PerformanceWin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/win/PerformanceWin.cpp	(revision 55749)
+++ trunk/src/VBox/Main/src-server/win/PerformanceWin.cpp	(revision 55769)
@@ -140,5 +140,5 @@
     mProcessStats.clear();
 
-    for (it = processes.begin(); it != processes.end() && RT_SUCCESS(rc); it++)
+    for (it = processes.begin(); it != processes.end() && RT_SUCCESS(rc); ++it)
     {
         RTPROCESS process = it->first;