Index: trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp	(revision 55988)
@@ -3183,6 +3183,6 @@
                     {
                         /* possible case if a disk image belongs to other virtual system (OVF package with multiple VMs inside) */
-                        LogWarning(("OVA/OVF import: Disk image %s was missed during import of VM %s\n",
-                                    oit->first.c_str(), vmNameEntry->strOvf.c_str()));
+                        Log1Warning(("OVA/OVF import: Disk image %s was missed during import of VM %s\n",
+                                     oit->first.c_str(), vmNameEntry->strOvf.c_str()));
                         NOREF(vmNameEntry);
                         ++oit;
@@ -3405,6 +3405,6 @@
             if(cImportedDisks < avsdeHDs.size())
             {
-                LogWarning(("Not all disk images were imported for VM %s. Check OVF description file.",
-                            vmNameEntry->strOvf.c_str()));
+                Log1Warning(("Not all disk images were imported for VM %s. Check OVF description file.",
+                             vmNameEntry->strOvf.c_str()));
             }
 
@@ -3689,6 +3689,6 @@
             {
                 /* possible case if a disk image belongs to other virtual system (OVF package with multiple VMs inside) */
-                LogWarning(("OVA/OVF import: Disk image %s was missed during import of VM %s\n",
-                            oit->first.c_str(), vmNameEntry->strOvf.c_str()));
+                Log1Warning(("OVA/OVF import: Disk image %s was missed during import of VM %s\n",
+                             oit->first.c_str(), vmNameEntry->strOvf.c_str()));
                 NOREF(vmNameEntry);
                 ++oit;
@@ -3934,6 +3934,6 @@
     if(cImportedDisks < avsdeHDs.size())
     {
-        LogWarning(("Not all disk images were imported for VM %s. Check OVF description file.",
-                    vmNameEntry->strOvf.c_str()));
+        Log1Warning(("Not all disk images were imported for VM %s. Check OVF description file.",
+                     vmNameEntry->strOvf.c_str()));
     }
 
Index: trunk/src/VBox/Main/src-server/MachineImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 55988)
@@ -761,7 +761,5 @@
         /* fetch the current error info */
         mData->mAccessError = com::ErrorInfo();
-        LogWarning(("Machine {%RTuuid} is inaccessible! [%ls]\n",
-                    mData->mUuid.raw(),
-                    mData->mAccessError.getText().raw()));
+        Log1Warning(("Machine {%RTuuid} is inaccessible! [%ls]\n", mData->mUuid.raw(), mData->mAccessError.getText().raw()));
 
         /* rollback all changes */
@@ -838,10 +836,10 @@
          * still valid). We'll call it ourselves below.
          */
-        LogWarningThisFunc(("Session machine is not NULL (%p), the direct session is still open!\n",
-                            (SessionMachine*)mData->mSession.mMachine));
+        Log1WarningThisFunc(("Session machine is not NULL (%p), the direct session is still open!\n",
+                             (SessionMachine*)mData->mSession.mMachine));
 
         if (Global::IsOnlineOrTransient(mData->mMachineState))
         {
-            LogWarningThisFunc(("Setting state to Aborted!\n"));
+            Log1WarningThisFunc(("Setting state to Aborted!\n"));
             /* set machine state using SessionMachine reimplementation */
             static_cast<Machine*>(mData->mSession.mMachine)->i_setMachineState(MachineState_Aborted);
@@ -874,5 +872,5 @@
     if (mData->flModifications)
     {
-        LogWarningThisFunc(("Discarding unsaved settings changes!\n"));
+        Log1WarningThisFunc(("Discarding unsaved settings changes!\n"));
         i_rollback(false /* aNotify */);
     }
@@ -4974,6 +4972,5 @@
             const char *sep = error.isEmpty() ? "" : ": ";
             CBSTR err = error.raw();
-            LogWarningFunc(("Someone vetoed! Change refused%s%ls\n",
-                            sep, err));
+            Log1WarningFunc(("Someone vetoed! Change refused%s%ls\n", sep, err));
             return setError(E_ACCESSDENIED,
                             tr("Could not set extra data because someone refused the requested change of '%s' to '%s'%s%ls"),
@@ -12194,6 +12191,5 @@
     mCollectorGuest = new pm::CollectorGuest(aMachine, pid);
     aCollector->registerGuest(mCollectorGuest);
-    LogAleksey(("{%p} " LOG_FN_FMT ": mCollectorGuest=%p\n",
-                this, __PRETTY_FUNCTION__, mCollectorGuest));
+    Log7(("{%p} " LOG_FN_FMT ": mCollectorGuest=%p\n", this, __PRETTY_FUNCTION__, mCollectorGuest));
 
     /* Create sub metrics */
@@ -12546,6 +12542,5 @@
     i_unregisterMetrics(mParent->i_performanceCollector(), mPeer);
     /* The guest must be unregistered after its metrics (@bugref{5949}). */
-    LogAleksey(("{%p} " LOG_FN_FMT ": mCollectorGuest=%p\n",
-                this, __PRETTY_FUNCTION__, mCollectorGuest));
+    Log7(("{%p} " LOG_FN_FMT ": mCollectorGuest=%p\n", this, __PRETTY_FUNCTION__, mCollectorGuest));
     if (mCollectorGuest)
     {
@@ -12558,6 +12553,5 @@
     if (aReason == Uninit::Abnormal)
     {
-        LogWarningThisFunc(("ABNORMAL client termination! (wasBusy=%d)\n",
-                             Global::IsOnlineOrTransient(lastState)));
+        Log1WarningThisFunc(("ABNORMAL client termination! (wasBusy=%d)\n", Global::IsOnlineOrTransient(lastState)));
 
         /* reset the state to Aborted */
@@ -12569,5 +12563,5 @@
     if (mData->flModifications)
     {
-        LogWarningThisFunc(("Discarding unsaved settings changes!\n"));
+        Log1WarningThisFunc(("Discarding unsaved settings changes!\n"));
         i_rollback(false /* aNotify */);
     }
@@ -12597,5 +12591,5 @@
             LogFlowThisFunc(("  remoteControl->Uninitialize() returned %08X\n", rc));
             if (FAILED(rc))
-                LogWarningThisFunc(("Forgot to close the remote session?\n"));
+                Log1WarningThisFunc(("Forgot to close the remote session?\n"));
             ++it;
         }
@@ -12643,5 +12637,5 @@
 
     if ((aReason == Uninit::Unexpected))
-        LogWarningThisFunc(("Unexpected SessionMachine uninitialization!\n"));
+        Log1WarningThisFunc(("Unexpected SessionMachine uninitialization!\n"));
 
     if (aReason != Uninit::Normal)
Index: trunk/src/VBox/Main/src-server/MediumImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MediumImpl.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/MediumImpl.cpp	(revision 55988)
@@ -6444,7 +6444,6 @@
     {
         m->strLastAccessError = lastAccessError;
-        LogWarningFunc(("'%s' is not accessible (error='%s', rc=%Rhrc, vrc=%Rrc)\n",
-                        location.c_str(), m->strLastAccessError.c_str(),
-                        rc, vrc));
+        Log1WarningFunc(("'%s' is not accessible (error='%s', rc=%Rhrc, vrc=%Rrc)\n",
+                         location.c_str(), m->strLastAccessError.c_str(), rc, vrc));
     }
 
Index: trunk/src/VBox/Main/src-server/Performance.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/Performance.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/Performance.cpp	(revision 55988)
@@ -115,15 +115,12 @@
     for (RTCPUID iCpu = 0; iCpu < RTCPUSET_MAX_CPUS; iCpu++)
     {
-        LogAleksey(("{%p} " LOG_FN_FMT ": Checking if CPU %d is member of online set...\n",
-                    this, __PRETTY_FUNCTION__, (int)iCpu));
+        Log7(("{%p} " LOG_FN_FMT ": Checking if CPU %d is member of online set...\n", this, __PRETTY_FUNCTION__, (int)iCpu));
         if (RTCpuSetIsMemberByIndex(&OnlineSet, iCpu))
         {
-            LogAleksey(("{%p} " LOG_FN_FMT ": Getting frequency for CPU %d...\n",
-                        this, __PRETTY_FUNCTION__, (int)iCpu));
+            Log7(("{%p} " LOG_FN_FMT ": Getting frequency for CPU %d...\n", this, __PRETTY_FUNCTION__, (int)iCpu));
             uint32_t uMHz = RTMpGetCurFrequency(RTMpCpuIdFromSetIndex(iCpu));
             if (uMHz != 0)
             {
-                LogAleksey(("{%p} " LOG_FN_FMT ": CPU %d %u MHz\n",
-                            this, __PRETTY_FUNCTION__, (int)iCpu, uMHz));
+                Log7(("{%p} " LOG_FN_FMT ": CPU %d %u MHz\n", this, __PRETTY_FUNCTION__, (int)iCpu, uMHz));
                 u64TotalMHz += uMHz;
                 cCpus++;
@@ -197,6 +194,5 @@
     NOREF(aFunction);
     NOREF(aText);
-    LogAleksey(("{%p} " LOG_FN_FMT ": CGRQEnable(mask=0x%x) %s\n",
-                aObject, aFunction, mMask, aText));
+    Log7(("{%p} " LOG_FN_FMT ": CGRQEnable(mask=0x%x) %s\n", aObject, aFunction, mMask, aText));
 }
 
@@ -212,6 +208,5 @@
     NOREF(aFunction);
     NOREF(aText);
-    LogAleksey(("{%p} " LOG_FN_FMT ": CGRQDisable(mask=0x%x) %s\n",
-                aObject, aFunction, mMask, aText));
+    Log7(("{%p} " LOG_FN_FMT ": CGRQDisable(mask=0x%x) %s\n", aObject, aFunction, mMask, aText));
 }
 
@@ -226,6 +221,5 @@
     NOREF(aFunction);
     NOREF(aText);
-    LogAleksey(("{%p} " LOG_FN_FMT ": CGRQAbort %s\n",
-                aObject, aFunction, aText));
+    Log7(("{%p} " LOG_FN_FMT ": CGRQAbort %s\n", aObject, aFunction, aText));
 }
 
@@ -266,7 +260,6 @@
         /* enable statistics collection; this is a remote call (!) */
         ret = directControl->EnableVMMStatistics(mCollectVMMStats);
-        LogAleksey(("{%p} " LOG_FN_FMT ": %sable VMM stats (%s)\n",
-                    this, __PRETTY_FUNCTION__, mCollectVMMStats?"En":"Dis",
-                    SUCCEEDED(ret)?"success":"failed"));
+        Log7(("{%p} " LOG_FN_FMT ": %sable VMM stats (%s)\n",
+              this, __PRETTY_FUNCTION__, mCollectVMMStats ? "En" : "Dis", SUCCEEDED(ret) ? "success" : "failed"));
     }
 
@@ -319,6 +312,6 @@
         {
             ret = mGuest->COMSETTER(StatisticsUpdateInterval)(1 /* 1 sec */);
-            LogAleksey(("{%p} " LOG_FN_FMT ": Set guest statistics update interval to 1 sec (%s)\n",
-                        this, __PRETTY_FUNCTION__, SUCCEEDED(ret)?"success":"failed"));
+            Log7(("{%p} " LOG_FN_FMT ": Set guest statistics update interval to 1 sec (%s)\n",
+                  this, __PRETTY_FUNCTION__, SUCCEEDED(ret) ? "success" : "failed"));
         }
     }
@@ -343,6 +336,6 @@
         HRESULT ret = mGuest->COMSETTER(StatisticsUpdateInterval)(0 /* off */);
         NOREF(ret);
-        LogAleksey(("{%p} " LOG_FN_FMT ": Set guest statistics update interval to 0 sec (%s)\n",
-                    this, __PRETTY_FUNCTION__, SUCCEEDED(ret)?"success":"failed"));
+        Log7(("{%p} " LOG_FN_FMT ": Set guest statistics update interval to 0 sec (%s)\n",
+              this, __PRETTY_FUNCTION__, SUCCEEDED(ret) ? "success" : "failed"));
         invalidate(VMSTATS_ALL);
     }
@@ -359,6 +352,5 @@
     }
 
-    LogAleksey(("{%p} " LOG_FN_FMT ": Attempted enqueue guest request when mManager is null\n",
-                this, __PRETTY_FUNCTION__));
+    Log7(("{%p} " LOG_FN_FMT ": Attempted enqueue guest request when mManager is null\n", this, __PRETTY_FUNCTION__));
     return E_POINTER;
 }
@@ -410,6 +402,5 @@
                             "CGMgr");
     NOREF(rc);
-    LogAleksey(("{%p} " LOG_FN_FMT ": RTThreadCreate returned %u (mThread=%p)\n",
-                this, __PRETTY_FUNCTION__, rc));
+    Log7(("{%p} " LOG_FN_FMT ": RTThreadCreate returned %u (mThread=%p)\n", this, __PRETTY_FUNCTION__, rc));
 }
 
@@ -422,9 +413,7 @@
     {
         /* We wait only if we were able to put the abort request to a queue */
-        LogAleksey(("{%p} " LOG_FN_FMT ": Waiting for CGM request processing thread to stop...\n",
-                    this, __PRETTY_FUNCTION__));
+        Log7(("{%p} " LOG_FN_FMT ": Waiting for CGM request processing thread to stop...\n", this, __PRETTY_FUNCTION__));
         rc = RTThreadWait(mThread, 1000 /* 1 sec */, &rcThread);
-        LogAleksey(("{%p} " LOG_FN_FMT ": RTThreadWait returned %u (thread exit code: %u)\n",
-                    this, __PRETTY_FUNCTION__, rc, rcThread));
+        Log7(("{%p} " LOG_FN_FMT ": RTThreadWait returned %u (thread exit code: %u)\n", this, __PRETTY_FUNCTION__, rc, rcThread));
     }
 }
@@ -440,6 +429,5 @@
     if (!mVMMStatsProvider)
         mVMMStatsProvider = pGuest;
-    LogAleksey(("{%p} " LOG_FN_FMT ": Registered guest=%p provider=%p\n",
-                this, __PRETTY_FUNCTION__, pGuest, mVMMStatsProvider));
+    Log7(("{%p} " LOG_FN_FMT ": Registered guest=%p provider=%p\n", this, __PRETTY_FUNCTION__, pGuest, mVMMStatsProvider));
 }
 
@@ -448,6 +436,5 @@
     int rc = S_OK;
 
-    LogAleksey(("{%p} " LOG_FN_FMT ": About to unregister guest=%p provider=%p\n",
-                this, __PRETTY_FUNCTION__, pGuest, mVMMStatsProvider));
+    Log7(("{%p} " LOG_FN_FMT ": About to unregister guest=%p provider=%p\n", this, __PRETTY_FUNCTION__, pGuest, mVMMStatsProvider));
     //mGuests.remove(pGuest); => destroyUnregistered()
     pGuest->unregister();
@@ -498,6 +485,5 @@
         }
     }
-    LogAleksey(("{%p} " LOG_FN_FMT ": LEAVE new provider=%p\n",
-                this, __PRETTY_FUNCTION__, mVMMStatsProvider));
+    Log7(("{%p} " LOG_FN_FMT ": LEAVE new provider=%p\n", this, __PRETTY_FUNCTION__, mVMMStatsProvider));
 }
 
@@ -511,6 +497,6 @@
             delete *it;
             it = mGuests.erase(it);
-            LogAleksey(("{%p} " LOG_FN_FMT ": Number of guests after erasing unregistered is %d\n",
-                        this, __PRETTY_FUNCTION__, mGuests.size()));
+            Log7(("{%p} " LOG_FN_FMT ": Number of guests after erasing unregistered is %d\n",
+                  this, __PRETTY_FUNCTION__, mGuests.size()));
         }
         else
@@ -537,12 +523,10 @@
          * and is barely noticable by humans.
          */
-        LogAleksey(("{%p} " LOG_FN_FMT ": Suspecting %s is stalled. Waiting for .5 sec...\n",
-                    this, __PRETTY_FUNCTION__,
-                    aRequest->getGuest()->getVMName().c_str()));
+        Log7(("{%p} " LOG_FN_FMT ": Suspecting %s is stalled. Waiting for .5 sec...\n",
+              this, __PRETTY_FUNCTION__, aRequest->getGuest()->getVMName().c_str()));
         RTThreadSleep(500 /* ms */);
         if (aRequest->getGuest() == mGuestBeingCalled) {
-            LogAleksey(("{%p} " LOG_FN_FMT ": Request processing stalled for %s\n",
-                        this, __PRETTY_FUNCTION__,
-                        aRequest->getGuest()->getVMName().c_str()));
+            Log7(("{%p} " LOG_FN_FMT ": Request processing stalled for %s\n",
+                  this, __PRETTY_FUNCTION__, aRequest->getGuest()->getVMName().c_str()));
             /* Request execution got stalled for this guest -- report an error */
             return E_FAIL;
@@ -561,6 +545,5 @@
     HRESULT rc = S_OK;
 
-    LogAleksey(("{%p} " LOG_FN_FMT ": Starting request processing loop...\n",
-                mgr, __PRETTY_FUNCTION__));
+    Log7(("{%p} " LOG_FN_FMT ": Starting request processing loop...\n", mgr, __PRETTY_FUNCTION__));
     while ((pReq = mgr->mQueue.pop()) != NULL)
     {
@@ -575,9 +558,7 @@
             break;
         if (FAILED(rc))
-            LogAleksey(("{%p} " LOG_FN_FMT ": request::execute returned %u\n",
-                        mgr, __PRETTY_FUNCTION__, rc));
-    }
-    LogAleksey(("{%p} " LOG_FN_FMT ": Exiting request processing loop... rc=%u\n",
-                        mgr, __PRETTY_FUNCTION__, rc));
+            Log7(("{%p} " LOG_FN_FMT ": request::execute returned %u\n", mgr, __PRETTY_FUNCTION__, rc));
+    }
+    Log7(("{%p} " LOG_FN_FMT ": Exiting request processing loop... rc=%u\n", mgr, __PRETTY_FUNCTION__, rc));
 
     return VINF_SUCCESS;
@@ -968,7 +949,6 @@
     if (provider)
     {
-        LogAleksey(("{%p} " LOG_FN_FMT ": provider=%p enabled=%s valid=%s...\n",
-                    this, __PRETTY_FUNCTION__, provider, provider->isEnabled()?"y":"n",
-                    provider->isValid(VMSTATS_VMM_RAM)?"y":"n"));
+        Log7(("{%p} " LOG_FN_FMT ": provider=%p enabled=%RTbool valid=%RTbool...\n",
+              this, __PRETTY_FUNCTION__, provider, provider->isEnabled(), provider->isValid(VMSTATS_VMM_RAM) ));
         if (provider->isValid(VMSTATS_VMM_RAM))
         {
@@ -993,7 +973,6 @@
         mSharedCurrent    = 0;
     }
-    LogAleksey(("{%p} " LOG_FN_FMT ": mAllocCurrent=%u mFreeCurrent=%u mBalloonedCurrent=%u mSharedCurrent=%u\n",
-                this, __PRETTY_FUNCTION__,
-                mAllocCurrent, mFreeCurrent, mBalloonedCurrent, mSharedCurrent));
+    Log7(("{%p} " LOG_FN_FMT ": mAllocCurrent=%u mFreeCurrent=%u mBalloonedCurrent=%u mSharedCurrent=%u\n",
+          this, __PRETTY_FUNCTION__, mAllocCurrent, mFreeCurrent, mBalloonedCurrent, mSharedCurrent));
     mAllocVMM->put(mAllocCurrent);
     mFreeVMM->put(mFreeCurrent);
@@ -1532,8 +1511,8 @@
     ElementList::const_iterator it;
 
-    //LogAleksey(("Filter::match(%p, %s)\n", static_cast<const IUnknown*> (object), name.c_str()));
+    //Log7(("Filter::match(%p, %s)\n", static_cast<const IUnknown*> (object), name.c_str()));
     for (it = mElements.begin(); it != mElements.end(); ++it)
     {
-        //LogAleksey(("...matching against(%p, %s)\n", static_cast<const IUnknown*> ((*it).first), (*it).second.c_str()));
+        //Log7(("...matching against(%p, %s)\n", static_cast<const IUnknown*> ((*it).first), (*it).second.c_str()));
         if ((*it).first.isNull() || (*it).first == object)
         {
@@ -1546,5 +1525,5 @@
         }
     }
-    //LogAleksey(("...no matches!\n"));
+    //Log7(("...no matches!\n"));
     return false;
 }
Index: trunk/src/VBox/Main/src-server/PerformanceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/PerformanceImpl.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/PerformanceImpl.cpp	(revision 55988)
@@ -582,6 +582,6 @@
 
     AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
-    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p name=%s\n", this, __PRETTY_FUNCTION__,
-                (void *)baseMetric->getObject(), baseMetric->getName()));
+    Log7(("{%p} " LOG_FN_FMT ": obj=%p name=%s\n", this, __PRETTY_FUNCTION__,
+          (void *)baseMetric->getObject(), baseMetric->getName()));
     m.baseMetrics.push_back (baseMetric);
     //LogFlowThisFuncLeave();
@@ -595,6 +595,5 @@
 
     AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
-    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p name=%s\n", this, __PRETTY_FUNCTION__,
-                (void *)metric->getObject(), metric->getName()));
+    Log7(("{%p} " LOG_FN_FMT ": obj=%p name=%s\n", this, __PRETTY_FUNCTION__, (void *)metric->getObject(), metric->getName()));
     m.metrics.push_back (metric);
     //LogFlowThisFuncLeave();
@@ -618,6 +617,6 @@
             ++n;
         }
-    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p, name=%s, marked %d metrics\n",
-                this, __PRETTY_FUNCTION__, (void *)aObject, name.c_str(), n));
+    Log7(("{%p} " LOG_FN_FMT ": obj=%p, name=%s, marked %d metrics\n",
+          this, __PRETTY_FUNCTION__, (void *)aObject, name.c_str(), n));
     //LogFlowThisFuncLeave();
 }
@@ -632,6 +631,5 @@
 
     AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
-    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p, name=%s\n", this,
-                __PRETTY_FUNCTION__, (void *)aObject, name.c_str()));
+    Log7(("{%p} " LOG_FN_FMT ": obj=%p, name=%s\n", this, __PRETTY_FUNCTION__, (void *)aObject, name.c_str()));
     MetricList::iterator it;
     for (it = m.metrics.begin(); it != m.metrics.end();)
@@ -756,11 +754,8 @@
      * Those should be destroyed now.
      */
-    LogAleksey(("{%p} " LOG_FN_FMT ": before remove_if: toBeCollected.size()=%d\n", this, __PRETTY_FUNCTION__,
-                toBeCollected.size()));
+    Log7(("{%p} " LOG_FN_FMT ": before remove_if: toBeCollected.size()=%d\n", this, __PRETTY_FUNCTION__, toBeCollected.size()));
     toBeCollected.remove_if(std::mem_fun(&pm::BaseMetric::isUnregistered));
-    LogAleksey(("{%p} " LOG_FN_FMT ": after remove_if: toBeCollected.size()=%d\n", this, __PRETTY_FUNCTION__,
-                toBeCollected.size()));
-    LogAleksey(("{%p} " LOG_FN_FMT ": before remove_if: m.baseMetrics.size()=%d\n", this, __PRETTY_FUNCTION__,
-                m.baseMetrics.size()));
+    Log7(("{%p} " LOG_FN_FMT ": after remove_if: toBeCollected.size()=%d\n", this, __PRETTY_FUNCTION__, toBeCollected.size()));
+    Log7(("{%p} " LOG_FN_FMT ": before remove_if: m.baseMetrics.size()=%d\n", this, __PRETTY_FUNCTION__, m.baseMetrics.size()));
     for (it = m.baseMetrics.begin(); it != m.baseMetrics.end();)
         if ((*it)->isUnregistered())
@@ -771,6 +766,5 @@
         else
             ++it;
-    LogAleksey(("{%p} " LOG_FN_FMT ": after remove_if: m.baseMetrics.size()=%d\n", this, __PRETTY_FUNCTION__,
-                m.baseMetrics.size()));
+    Log7(("{%p} " LOG_FN_FMT ": after remove_if: m.baseMetrics.size()=%d\n", this, __PRETTY_FUNCTION__, m.baseMetrics.size()));
     /*
      * Now when we have destroyed all base metrics that could
Index: trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 55988)
@@ -803,6 +803,5 @@
             int vrc = RTThreadWait(m->threadAsyncEvent, 60000, NULL);
             if (RT_FAILURE(vrc))
-                LogWarningFunc(("RTThreadWait(%RTthrd) -> %Rrc\n",
-                                m->threadAsyncEvent, vrc));
+                Log1WarningFunc(("RTThreadWait(%RTthrd) -> %Rrc\n", m->threadAsyncEvent, vrc));
         }
         else
@@ -2006,6 +2005,5 @@
             const char *sep = error.isEmpty() ? "" : ": ";
             CBSTR err = error.raw();
-            LogWarningFunc(("Someone vetoed! Change refused%s%ls\n",
-                            sep, err));
+            Log1WarningFunc(("Someone vetoed! Change refused%s%ls\n", sep, err));
             return setError(E_ACCESSDENIED,
                             tr("Could not set extra data because someone refused the requested change of '%s' to '%s'%s%ls"),
@@ -2304,6 +2302,6 @@
     {
         if (getObjectState().getState() != ObjectState::Ready)
-            LogWarningFunc(("VirtualBox has been uninitialized (state=%d), the event is discarded!\n",
-                            getObjectState().getState()));
+            Log1WarningFunc(("VirtualBox has been uninitialized (state=%d), the event is discarded!\n",
+                             getObjectState().getState()));
             // return S_OK
         else if (    (m->pAsyncEventQ)
@@ -4820,6 +4818,6 @@
     if (!autoCaller.isOk())
     {
-        LogWarningFunc(("VirtualBox has been uninitialized (state=%d), the callback event is discarded!\n",
-                        mVirtualBox->getObjectState().getState()));
+        Log1WarningFunc(("VirtualBox has been uninitialized (state=%d), the callback event is discarded!\n",
+                         mVirtualBox->getObjectState().getState()));
         /* We don't need mVirtualBox any more, so release it */
         mVirtualBox = NULL;
Index: trunk/src/VBox/Main/src-server/darwin/PerformanceDarwin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/darwin/PerformanceDarwin.cpp	(revision 55980)
+++ trunk/src/VBox/Main/src-server/darwin/PerformanceDarwin.cpp	(revision 55988)
@@ -130,5 +130,5 @@
 static int getProcessInfo(RTPROCESS process, struct proc_taskinfo *tinfo)
 {
-    LogAleksey(("getProcessInfo() getting info for %d", process));
+    Log7(("getProcessInfo() getting info for %d", process));
     int nb = proc_pidinfo(process, PROC_PIDTASKINFO, 0,  tinfo, sizeof(*tinfo));
     if (nb <= 0)