Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 56138)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 56145)
@@ -789,5 +789,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&About VirtualBox..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Show a window with product information"));
+        setStatusTip(QApplication::translate("UIActionPool", "Display window with product information"));
     }
 };
@@ -832,6 +832,6 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "&Preferences...", "global settings"));
-        setStatusTip(QApplication::translate("UIActionPool", "Display the global settings window"));
+        setName(QApplication::translate("UIActionPool", "&Preferences...", "global preferences window"));
+        setStatusTip(QApplication::translate("UIActionPool", "Display the global preferences window"));
     }
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 56138)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 56145)
@@ -268,5 +268,5 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "Save State"));
+        setName(QApplication::translate("UIActionPool", "&Save State"));
         setStatusTip(QApplication::translate("UIActionPool", "Save the state of the virtual machine"));
     }
@@ -638,5 +638,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Take Screensh&ot..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Take the guest display screenshot"));
+        setStatusTip(QApplication::translate("UIActionPool", "Take a guest display screenshot"));
     }
 };
@@ -724,5 +724,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Video Capture"));
-        setStatusTip(QApplication::translate("UIActionPool", "Activate the guest display video capture"));
+        setStatusTip(QApplication::translate("UIActionPool", "Enable guest display video capture"));
     }
 };
@@ -1030,5 +1030,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Keyboard Settings..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Display the global settings window to configure keyboard shortcuts"));
+        setStatusTip(QApplication::translate("UIActionPool", "Display the global preferences window to configure keyboard shortcuts"));
     }
 };
@@ -1064,5 +1064,5 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "&Insert %1").arg("Ctrl-Alt-Del"));
+        setName(QApplication::translate("UIActionPool", "&Insert %1", "that means send the %1 key sequence to the virtual machine").arg("Ctrl-Alt-Del"));
         setStatusTip(QApplication::translate("UIActionPool", "Send the %1 sequence to the virtual machine").arg("Ctrl-Alt-Del"));
     }
@@ -1100,5 +1100,5 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "&Insert %1").arg("Ctrl-Alt-Backspace"));
+        setName(QApplication::translate("UIActionPool", "&Insert %1", "that means send the %1 key sequence to the virtual machine").arg("Ctrl-Alt-Backspace"));
         setStatusTip(QApplication::translate("UIActionPool", "Send the %1 sequence to the virtual machine").arg("Ctrl-Alt-Backspace"));
     }
@@ -1131,5 +1131,5 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "&Insert %1").arg("Ctrl-Break"));
+        setName(QApplication::translate("UIActionPool", "&Insert %1", "that means send the %1 key sequence to the virtual machine").arg("Ctrl-Break"));
         setStatusTip(QApplication::translate("UIActionPool", "Send the %1 sequence to the virtual machine").arg("Ctrl-Break"));
     }
@@ -1161,5 +1161,5 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "&Insert %1").arg("Insert"));
+        setName(QApplication::translate("UIActionPool", "&Insert %1", "that means send the %1 key sequence to the virtual machine").arg("Insert"));
         setStatusTip(QApplication::translate("UIActionPool", "Send the %1 sequence to the virtual machine").arg("Insert"));
     }
@@ -1544,5 +1544,5 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "Drag and Drop"));
+        setName(QApplication::translate("UIActionPool", "&Drag and Drop"));
     }
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 56138)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 56145)
@@ -832,5 +832,5 @@
         {
             QAction *pAction = actions.at(i);
-            pAction->setText(QApplication::translate("UIMachineLogic", "Preview Monitor %1").arg(pAction->data().toInt() + 1));
+            pAction->setText(QApplication::translate("UIActionPool", "Preview Monitor %1").arg(pAction->data().toInt() + 1));
         }
     }
@@ -1410,5 +1410,5 @@
 
     /* Search for the max available filter index: */
-    QString strNameTemplate = QApplication::translate("UIMachineLogic", "Snapshot %1");
+    QString strNameTemplate = VBoxTakeSnapshotDlg::tr("Snapshot %1");
     int iMaxSnapshotIndex = searchMaxSnapshotIndex(machine(), machine().FindSnapshot(QString()), strNameTemplate);
     pDlg->mLeName->setText(strNameTemplate.arg(++ iMaxSnapshotIndex));
@@ -2198,5 +2198,6 @@
     {
         QAction *pAction = pMenu->addAction(UIIconPool::iconSet(adapterData[iSlot] ? ":/connect_16px.png": ":/disconnect_16px.png"),
-                                            adapterData.size() == 1 ? tr("Connect Network Adapter") : tr("Connect Network Adapter %1").arg(iSlot + 1),
+                                            adapterData.size() == 1 ? UIActionPool::tr("&Connect Network Adapter") :
+                                                                      UIActionPool::tr("Connect Network Adapter &%1").arg(iSlot + 1),
                                             this, SLOT(sltToggleNetworkAdapterConnection()));
         pAction->setProperty("slot", iSlot);
@@ -2219,6 +2220,6 @@
         QAction *pEmptyMenuAction = pMenu->addAction(UIIconPool::iconSet(":/usb_unavailable_16px.png",
                                                                          ":/usb_unavailable_disabled_16px.png"),
-                                                     tr("No USB Devices Connected"));
-        pEmptyMenuAction->setToolTip(tr("No supported devices connected to the host PC"));
+                                                     UIActionPool::tr("No USB Devices Connected"));
+        pEmptyMenuAction->setToolTip(UIActionPool::tr("No supported devices connected to the host PC"));
         pEmptyMenuAction->setEnabled(false);
     }
@@ -2265,6 +2266,6 @@
         QAction *pEmptyMenuAction = pMenu->addAction(UIIconPool::iconSet(":/web_camera_unavailable_16px.png",
                                                                          ":/web_camera_unavailable_disabled_16px.png"),
-                                                     tr("No Webcams Connected"));
-        pEmptyMenuAction->setToolTip(tr("No supported webcams connected to the host PC"));
+                                                     UIActionPool::tr("No Webcams Connected"));
+        pEmptyMenuAction->setToolTip(UIActionPool::tr("No supported webcams connected to the host PC"));
         pEmptyMenuAction->setEnabled(false);
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.cpp	(revision 56138)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.cpp	(revision 56145)
@@ -241,5 +241,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&New Machine..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Create a new virtual machine"));
+        setStatusTip(QApplication::translate("UIActionPool", "Create new virtual machine"));
         setToolTip(text().remove('&').remove('.') +
                    (shortcut().toString().isEmpty() ? "" : QString(" (%1)").arg(shortcut().toString())));
@@ -271,5 +271,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Add Machine..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Add an existing virtual machine"));
+        setStatusTip(QApplication::translate("UIActionPool", "Add existing virtual machine"));
     }
 };
@@ -299,5 +299,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Rena&me Group..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Rename the selected virtual machine group"));
+        setStatusTip(QApplication::translate("UIActionPool", "Rename selected virtual machine group"));
     }
 };
@@ -326,6 +326,6 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "&Ungroup..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Ungroup items of the selected virtual machine group"));
+        setName(QApplication::translate("UIActionPool", "&Ungroup"));
+        setStatusTip(QApplication::translate("UIActionPool", "Ungroup the items of selected virtual machine group"));
     }
 };
@@ -349,6 +349,6 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "Sort"));
-        setStatusTip(QApplication::translate("UIActionPool", "Sort the items of the selected virtual machine group alphabetically"));
+        setName(QApplication::translate("UIActionPool", "&Sort"));
+        setStatusTip(QApplication::translate("UIActionPool", "Sort the items of selected virtual machine group alphabetically"));
     }
 };
@@ -396,5 +396,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&New..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Create a new virtual machine"));
+        setStatusTip(QApplication::translate("UIActionPool", "Create new virtual machine"));
         setToolTip(text().remove('&').remove('.') +
                    (shortcut().toString().isEmpty() ? "" : QString(" (%1)").arg(shortcut().toString())));
@@ -426,5 +426,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Add..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Add an existing virtual machine"));
+        setStatusTip(QApplication::translate("UIActionPool", "Add existing virtual machine"));
     }
 };
@@ -454,5 +454,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Gro&up"));
-        setStatusTip(QApplication::translate("UIActionPool", "Add a new group based on the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Add new group based on selected virtual machines"));
     }
 };
@@ -514,5 +514,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Cl&one..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Clone the selected virtual machine"));
+        setStatusTip(QApplication::translate("UIActionPool", "Clone selected virtual machine"));
     }
 };
@@ -544,5 +544,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Remove..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Remove the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Remove selected virtual machines"));
     }
 };
@@ -575,5 +575,5 @@
                 showMenu();
                 setName(QApplication::translate("UIActionPool", "S&tart"));
-                setStatusTip(QApplication::translate("UIActionPool", "Start the selected virtual machines"));
+                setStatusTip(QApplication::translate("UIActionPool", "Start selected virtual machines"));
                 setToolTip(text().remove('&').remove('.') +
                            (shortcut().toString().isEmpty() ? "" : QString(" (%1)").arg(shortcut().toString())));
@@ -584,5 +584,5 @@
                 hideMenu();
                 setName(QApplication::translate("UIActionPool", "S&how"));
-                setStatusTip(QApplication::translate("UIActionPool", "Switch to the windows of the selected virtual machines"));
+                setStatusTip(QApplication::translate("UIActionPool", "Switch to the windows of selected virtual machines"));
                 setToolTip(text().remove('&').remove('.') +
                            (shortcut().toString().isEmpty() ? "" : QString(" (%1)").arg(shortcut().toString())));
@@ -616,5 +616,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Normal Start"));
-        setStatusTip(QApplication::translate("UIActionPool", "Start the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Start selected virtual machines"));
     }
 };
@@ -641,5 +641,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Headless Start"));
-        setStatusTip(QApplication::translate("UIActionPool", "Start the selected virtual machines in the background"));
+        setStatusTip(QApplication::translate("UIActionPool", "Start selected virtual machines in the background"));
     }
 };
@@ -666,5 +666,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Detachable Start"));
-        setStatusTip(QApplication::translate("UIActionPool", "Start the selected virtual machines with the option of continuing them in the background"));
+        setStatusTip(QApplication::translate("UIActionPool", "Start selected virtual machines with the option of continuing them in the background"));
     }
 };
@@ -694,5 +694,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Pause"));
-        setStatusTip(QApplication::translate("UIActionPool", "Suspend the execution of the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Suspend the execution of selected virtual machines"));
     }
 };
@@ -722,5 +722,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Reset"));
-        setStatusTip(QApplication::translate("UIActionPool", "Reset the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Reset selected virtual machines"));
     }
 };
@@ -752,6 +752,6 @@
     {
         setIconText(QApplication::translate("UIActionPool", "Discard"));
-        setName(QApplication::translate("UIActionPool", "D&iscard saved state..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Discard the saved state of the selected virtual machines"));
+        setName(QApplication::translate("UIActionPool", "D&iscard Saved State..."));
+        setStatusTip(QApplication::translate("UIActionPool", "Discard the saved state of selected virtual machines"));
         setToolTip(text().remove('&').remove('.') +
                    (shortcut().toString().isEmpty() ? "" : QString(" (%1)").arg(shortcut().toString())));
@@ -788,5 +788,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Show &Log..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Show the log files of the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Show the log files of selected virtual machines"));
     }
 };
@@ -812,6 +812,6 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "Re&fresh..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Refresh the accessibility state of the selected virtual machines"));
+        setName(QApplication::translate("UIActionPool", "Re&fresh"));
+        setStatusTip(QApplication::translate("UIActionPool", "Refresh the accessibility state of selected virtual machines"));
     }
 };
@@ -836,11 +836,11 @@
     {
 #if defined(Q_WS_MAC)
-        setName(QApplication::translate("UIActionPool", "Show in Finder"));
+        setName(QApplication::translate("UIActionPool", "S&how in Finder"));
         setStatusTip(QApplication::translate("UIActionPool", "Show the VirtualBox Machine Definition files in Finder"));
 #elif defined(Q_WS_WIN)
-        setName(QApplication::translate("UIActionPool", "Show in Explorer"));
+        setName(QApplication::translate("UIActionPool", "S&how in Explorer"));
         setStatusTip(QApplication::translate("UIActionPool", "Show the VirtualBox Machine Definition files in Explorer"));
 #else
-        setName(QApplication::translate("UIActionPool", "Show in File Manager"));
+        setName(QApplication::translate("UIActionPool", "S&how in File Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Show the VirtualBox Machine Definition files in the File Manager"));
 #endif
@@ -867,8 +867,8 @@
     {
 #if defined(Q_WS_MAC)
-        setName(QApplication::translate("UIActionPool", "Create Alias on Desktop"));
+        setName(QApplication::translate("UIActionPool", "Cr&eate Alias on Desktop"));
         setStatusTip(QApplication::translate("UIActionPool", "Creates an alias files to the VirtualBox Machine Definition files on your desktop"));
 #else
-        setName(QApplication::translate("UIActionPool", "Create Shortcut on Desktop"));
+        setName(QApplication::translate("UIActionPool", "Cr&eate Shortcut on Desktop"));
         setStatusTip(QApplication::translate("UIActionPool", "Creates a shortcut files to the VirtualBox Machine Definition files on your desktop"));
 #endif
@@ -894,6 +894,6 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "Sort"));
-        setStatusTip(QApplication::translate("UIActionPool", "Sort the group of the first selected virtual machine alphabetically"));
+        setName(QApplication::translate("UIActionPool", "&Sort"));
+        setStatusTip(QApplication::translate("UIActionPool", "Sort the group of first selected virtual machine alphabetically"));
     }
 };
@@ -940,6 +940,6 @@
     void retranslateUi()
     {
-        setName(QApplication::translate("UIActionPool", "Save State"));
-        setStatusTip(QApplication::translate("UIActionPool", "Save the state of the selected virtual machines"));
+        setName(QApplication::translate("UIActionPool", "&Save State"));
+        setStatusTip(QApplication::translate("UIActionPool", "Save the state of selected virtual machines"));
     }
 };
@@ -969,5 +969,5 @@
     {
         setName(QApplication::translate("UIActionPool", "ACPI Sh&utdown"));
-        setStatusTip(QApplication::translate("UIActionPool", "Send the ACPI Shutdown signal to the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Send the ACPI Shutdown signal to selected virtual machines"));
     }
 };
@@ -997,5 +997,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Po&wer Off"));
-        setStatusTip(QApplication::translate("UIActionPool", "Power off the selected virtual machines"));
+        setStatusTip(QApplication::translate("UIActionPool", "Power off selected virtual machines"));
     }
 };